/*
Copyright (c) Dale Anson, 2004

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in the
 documentation and/or other materials provided with the distribution.
 3. The name of the author may not be used to endorse or promote products
 derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package ise.dbconsole.command;

import ise.dbconsole.*;
import ise.dbconsole.to.*;
import ise.library.*;
import ise.library.ascii.*;

import java.io.*;
import java.util.*;
import java.util.prefs.*;

/**
 * Copyright 2003
 *
 * @version   $Revision: 18 $
 */
public class ChangePasswordCommand extends Command {
    /**
     * Description of the Method
     *
     * @return   Description of the Returned Value
     */
    public String execute() {
        return execute( null );
    }

    /**
     * Description of the Method
     *
     * @param data Must be a User
     * @return     the new password or null if not changed
     */
    public String execute( Object data ) {
        DbConsole console = DbConsole.getInstance();
        PrintStream out = console.getOut();

        User user = (User)data;
        if (user == null) {
            return null;
        }
        int try_count = 0;
        String new_password = "";
        while ( try_count < 3 ) {
            Input input = new PasswordInput( DbConsole.prompt + Bundle.BUNDLE.getString( "enterNewPassword" ) + ": " );
            new_password = input.getInput();
            input = new PasswordInput( DbConsole.prompt + Bundle.BUNDLE.getString( "enterNewPasswordRepeat" ) + ": " );
            String new_password2 = input.getInput();
            if ( new_password.equals( new_password2 ) ) {
                break;
            }
            out.println( Bundle.BUNDLE.getString( "passwordsDontMatch" ) );
            ++try_count;
            continue;
        }
        if ( try_count == 3 ) {
            out.println( Bundle.BUNDLE.getString( "tooManyTries" )  );
            return null;
        }
        user.setPassword( new_password );
        out.println(Bundle.BUNDLE.getString( "passwordChanged" ));
        return new_password;
    }

    /**
     * Description of the Method
     *
     * @return   Description of the Returned Value
     */
    public boolean showSpinner() {
        return false;
    }
}

