/*
Copyright (c) Dale Anson, 2004

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in the
 documentation and/or other materials provided with the distribution.
 3. The name of the author may not be used to endorse or promote products
 derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

package ise.dbconsole.command;

import ise.dbconsole.*;


/**
 * @author Dale Anson, Sep 2004
 * @version   $Revision: 10 $
 */
public class ListColumnsCommand extends Command {
    /** Description of the Method */
    public String execute() {
        return null;
    }

    /**
     * Get a list of columns in the given schema.table
     *
     * @param data "schema.table", or "schema table", or if default schema is set,
     * "table".  Added "brief" as a parameter, if used, must be first parameter
     */
    public String execute( Object data ) {
        if ( data == null ) {
            return null;
        }

        String[] commands = data.toString().split( "[ .]" );
        if ( commands.length == 0 ) {
            return null;
        }

        boolean brief = "brief".equalsIgnoreCase( commands[ 1 ] );
        int offset = brief ? 1 : 0;
        int command_cnt = brief ? commands.length - 1 : commands.length;
        switch ( command_cnt ) {
            case 2:
                // table name only
                return DbConsole.getInstance().getDAO().listColumns( null, commands[ 1 + offset ], brief );
            case 3:
                // schema name and table name
                return DbConsole.getInstance().getDAO().listColumns( commands[ 1 + offset ], commands[ 2 + offset ], brief );
            default:
                return null;
        }
    }
}
