
package ise.library;

import java.util.*;

/**
 * A set that has a maximum size.  This is useful for creating a list without
 * duplicates in the order they were added and with a maximum size, like might
 * be found on a "recent files" list.
 * @deprecated use ArrayList instead
 */
public class RecentSet extends ArrayList {

    private int maxSize = Integer.MAX_VALUE;

    public RecentSet() {
        super();
    }

    public RecentSet(int max) {
        super();
        maxSize = max;
    }

    public void setMaxSize( int max ) {
        maxSize = max;
    }

    public int getMaxSize() {
        return maxSize;
    }

    public boolean add( Object o ) {
        while ( size() >= maxSize ) {
            Iterator it = iterator();
            Object first = it.next();
            remove( first );
        }
        return super.add( o );
    }
}
